diff -Naur openssl-1.0.0q.orig/crypto/err/err_prn.c openssl-1.0.0q/crypto/err/err_prn.c
--- openssl-1.0.0q.orig/crypto/err/err_prn.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/err/err_prn.c	2017-04-25 16:23:40.328322172 +0200
@@ -56,19 +56,26 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/crypto.h>
 #include <openssl/buffer.h>
 #include <openssl/err.h>
 
+#ifndef OPERA_SMALL_VERSION
 void ERR_print_errors_cb(int (*cb)(const char *str, size_t len, void *u),
 			 void *u)
 	{
 	unsigned long l;
-	char buf[256];
-	char buf2[4096];
+	char buf[256];		/* ARRAY OK UNUSED OPERA 2004-02-18 yngve */
+	char buf2[4096];	/* ARRAY OK UNUSED OPERA 2004-02-18 yngve */
 	const char *file,*data;
 	int line,flags;
 	unsigned long es;
@@ -81,7 +88,7 @@
 		ERR_error_string_n(l, buf, sizeof buf);
 		BIO_snprintf(buf2, sizeof(buf2), "%lu:%s:%s:%d:%s\n", es, buf,
 			file, line, (flags & ERR_TXT_STRING) ? data : "");
-		if (cb(buf2, strlen(buf2), u) <= 0)
+		if (cb(buf2, op_strlen(buf2), u) <= 0)
 			break; /* abort outputting the error report */
 		}
 	}
@@ -112,3 +119,4 @@
 	}
 
 	
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/.gitignore openssl-1.0.0q/crypto/evp/.gitignore
--- openssl-1.0.0q.orig/crypto/evp/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/.gitignore	2017-04-25 16:23:40.329321740 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/evp/bio_b64.c openssl-1.0.0q/crypto/evp/bio_b64.c
--- openssl-1.0.0q.orig/crypto/evp/bio_b64.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/bio_b64.c	2017-04-25 16:23:40.330322147 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/evp.h>
@@ -87,11 +89,11 @@
 	int start;		/* have we started decoding yet? */
 	int cont;		/* <= 0 when finished */
 	EVP_ENCODE_CTX base64;
-	char buf[EVP_ENCODE_LENGTH(B64_BLOCK_SIZE)+10];
-	char tmp[B64_BLOCK_SIZE];
+	char buf[EVP_ENCODE_LENGTH(B64_BLOCK_SIZE)+10]; /* ARRAY OK UNUSED 2007-04-23 yngve */
+	char tmp[B64_BLOCK_SIZE]; /* ARRAY OK UNUSED 2007-04-23 yngve */
 	} BIO_B64_CTX;
 
-static BIO_METHOD methods_b64=
+static const BIO_METHOD methods_b64=
 	{
 	BIO_TYPE_BASE64,"base64 encoding",
 	b64_write,
@@ -104,7 +106,7 @@
 	b64_callback_ctrl,
 	};
 
-BIO_METHOD *BIO_f_base64(void)
+const BIO_METHOD *BIO_f_base64(void)
 	{
 	return(&methods_b64);
 	}
@@ -170,7 +172,7 @@
 		i=ctx->buf_len-ctx->buf_off;
 		if (i > outl) i=outl;
 		OPENSSL_assert(ctx->buf_off+i < (int)sizeof(ctx->buf));
-		memcpy(out,&(ctx->buf[ctx->buf_off]),i);
+		op_memcpy(out,&(ctx->buf[ctx->buf_off]),i);
 		ret=i;
 		out+=i;
 		outl-=i;
@@ -325,7 +327,7 @@
 			 * number consumed */
 			if (jj != i)
 				{
-				memmove(ctx->tmp, &ctx->tmp[jj], i-jj);
+				op_memmove(ctx->tmp, &ctx->tmp[jj], i-jj);
 				ctx->tmp_len=i-jj;
 				}
 			ctx->buf_len=0;
@@ -355,7 +357,7 @@
 		else
 			i=outl;
 
-		memcpy(out,ctx->buf,i);
+		op_memcpy(out,ctx->buf,i);
 		ret+=i;
 		ctx->buf_off=i;
 		if (ctx->buf_off == ctx->buf_len)
@@ -427,7 +429,7 @@
 				/* There's a theoretical possibility for this */
 				if (n > inl) 
 					n=inl;
-				memcpy(&(ctx->tmp[ctx->tmp_len]),in,n);
+				op_memcpy(&(ctx->tmp[ctx->tmp_len]),in,n);
 				ctx->tmp_len+=n;
 				ret += n;
 				if (ctx->tmp_len < 3)
@@ -443,7 +445,7 @@
 				{
 				if (n < 3)
 					{
-					memcpy(ctx->tmp,in,n);
+					op_memcpy(ctx->tmp,in,n);
 					ctx->tmp_len=n;
 					ret += n;
 					break;
diff -Naur openssl-1.0.0q.orig/crypto/evp/bio_enc.c openssl-1.0.0q/crypto/evp/bio_enc.c
--- openssl-1.0.0q.orig/crypto/evp/bio_enc.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/bio_enc.c	2017-04-25 16:23:40.331321995 +0200
@@ -56,11 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/evp.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int enc_write(BIO *h, const char *buf, int num);
 static int enc_read(BIO *h, char *buf, int size);
@@ -84,11 +89,10 @@
 	/* buf is larger than ENC_BLOCK_SIZE because EVP_DecryptUpdate
 	 * can return up to a block more data than is presented to it
 	 */
-	char buf[ENC_BLOCK_SIZE+BUF_OFFSET+2];
+	char buf[ENC_BLOCK_SIZE+BUF_OFFSET+2]; /* ARRAY OK UNUSED 2007-04-23  yngve */
 	} BIO_ENC_CTX;
 
-static BIO_METHOD methods_enc=
-	{
+BIO_METHOD_CONST_ITEM(bio_enc__methods_enc,
 	BIO_TYPE_CIPHER,"cipher",
 	enc_write,
 	enc_read,
@@ -97,10 +101,11 @@
 	enc_ctrl,
 	enc_new,
 	enc_free,
-	enc_callback_ctrl,
-	};
+	enc_callback_ctrl
+	);
+#define methods_enc OPENSSL_GLOBAL_ITEM_NAME(bio_enc__methods_enc)
 
-BIO_METHOD *BIO_f_cipher(void)
+const BIO_METHOD *BIO_f_cipher(void)
 	{
 	return(&methods_enc);
 	}
@@ -155,7 +160,7 @@
 		{
 		i=ctx->buf_len-ctx->buf_off;
 		if (i > outl) i=outl;
-		memcpy(out,&(ctx->buf[ctx->buf_off]),i);
+		op_memcpy(out,&(ctx->buf[ctx->buf_off]),i);
 		ret=i;
 		out+=i;
 		outl-=i;
@@ -216,7 +221,7 @@
 		else
 			i=outl;
 		if (i <= 0) break;
-		memcpy(out,ctx->buf,i);
+		op_memcpy(out,ctx->buf,i);
 		ret+=i;
 		ctx->buf_off=i;
 		outl-=i;
@@ -378,12 +383,7 @@
 	long ret=1;
 
 	if (b->next_bio == NULL) return(0);
-	switch (cmd)
-		{
-	default:
-		ret=BIO_callback_ctrl(b->next_bio,cmd,fp);
-		break;
-		}
+	ret=BIO_callback_ctrl(b->next_bio,cmd,fp);
 	return(ret);
 	}
 
@@ -400,7 +400,7 @@
 
 	b->init=1;
 	ctx=(BIO_ENC_CTX *)b->ptr;
-	memcpy(ctx->cipher,c,sizeof(EVP_CIPHER_CTX));
+	op_memcpy(ctx->cipher,c,sizeof(EVP_CIPHER_CTX));
 	
 	if (b->callback != NULL)
 		b->callback(b,BIO_CB_CTRL,(char *)c,BIO_CTRL_SET,e,1L);
diff -Naur openssl-1.0.0q.orig/crypto/evp/bio_md.c openssl-1.0.0q/crypto/evp/bio_md.c
--- openssl-1.0.0q.orig/crypto/evp/bio_md.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/bio_md.c	2017-04-25 16:23:40.332322401 +0200
@@ -56,11 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/evp.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* BIO_put and BIO_get both add to the digest,
  * BIO_gets returns the digest */
@@ -74,8 +79,7 @@
 static int md_free(BIO *data);
 static long md_callback_ctrl(BIO *h,int cmd,bio_info_cb *fp);
 
-static BIO_METHOD methods_md=
-	{
+BIO_METHOD_CONST_ITEM(bio_md__methods_md,
 	BIO_TYPE_MD,"message digest",
 	md_write,
 	md_read,
@@ -84,10 +88,11 @@
 	md_ctrl,
 	md_new,
 	md_free,
-	md_callback_ctrl,
-	};
+	md_callback_ctrl
+	);
+#define methods_md OPENSSL_GLOBAL_ITEM_NAME(bio_md__methods_md)
 
-BIO_METHOD *BIO_f_md(void)
+const BIO_METHOD *BIO_f_md(void)
 	{
 	return(&methods_md);
 	}
@@ -108,7 +113,7 @@
 static int md_free(BIO *a)
 	{
 	if (a == NULL) return(0);
-	EVP_MD_CTX_destroy(a->ptr);
+	EVP_MD_CTX_destroy((EVP_MD_CTX *)a->ptr);
 	a->ptr=NULL;
 	a->init=0;
 	a->flags=0;
@@ -121,7 +126,7 @@
 	EVP_MD_CTX *ctx;
 
 	if (out == NULL) return(0);
-	ctx=b->ptr;
+	ctx=(EVP_MD_CTX *)b->ptr;
 
 	if ((ctx == NULL) || (b->next_bio == NULL)) return(0);
 
@@ -145,7 +150,7 @@
 	EVP_MD_CTX *ctx;
 
 	if ((in == NULL) || (inl <= 0)) return(0);
-	ctx=b->ptr;
+	ctx=(EVP_MD_CTX *)b->ptr;
 
 	if ((ctx != NULL) && (b->next_bio != NULL))
 		ret=BIO_write(b->next_bio,in,inl);
@@ -173,7 +178,7 @@
 	long ret=1;
 	BIO *dbio;
 
-	ctx=b->ptr;
+	ctx=(EVP_MD_CTX *)b->ptr;
 
 	switch (cmd)
 		{
@@ -188,14 +193,14 @@
 	case BIO_C_GET_MD:
 		if (b->init)
 			{
-			ppmd=ptr;
+			ppmd=(const EVP_MD **)ptr;
 			*ppmd=ctx->digest;
 			}
 		else
 			ret=0;
 		break;
 	case BIO_C_GET_MD_CTX:
-		pctx=ptr;
+		pctx=(EVP_MD_CTX **)ptr;
 		*pctx=ctx;
 		b->init = 1;
 		break;
@@ -212,14 +217,14 @@
 		break;
 
 	case BIO_C_SET_MD:
-		md=ptr;
+		md=(EVP_MD *)ptr;
 		ret = EVP_DigestInit_ex(ctx,md, NULL);
 		if (ret > 0)
 			b->init=1;
 		break;
 	case BIO_CTRL_DUP:
-		dbio=ptr;
-		dctx=dbio->ptr;
+		dbio=(BIO *)ptr;
+		dctx=(EVP_MD_CTX *)dbio->ptr;
 		EVP_MD_CTX_copy_ex(dctx,ctx);
 		b->init=1;
 		break;
@@ -235,12 +240,7 @@
 	long ret=1;
 
 	if (b->next_bio == NULL) return(0);
-	switch (cmd)
-		{
-	default:
-		ret=BIO_callback_ctrl(b->next_bio,cmd,fp);
-		break;
-		}
+	ret=BIO_callback_ctrl(b->next_bio,cmd,fp);
 	return(ret);
 	}
 
@@ -250,7 +250,7 @@
 	unsigned int ret;
 
 
-	ctx=bp->ptr;
+	ctx=(EVP_MD_CTX *)bp->ptr;
 	if (size < ctx->digest->md_size)
 		return(0);
 	if (EVP_DigestFinal_ex(ctx,(unsigned char *)buf,&ret)<=0) 
@@ -267,4 +267,3 @@
 	return(-1);
 	}
 */
-
diff -Naur openssl-1.0.0q.orig/crypto/evp/bio_ok.c openssl-1.0.0q/crypto/evp/bio_ok.c
--- openssl-1.0.0q.orig/crypto/evp/bio_ok.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/bio_ok.c	2017-04-25 16:23:40.333321410 +0200
@@ -117,10 +117,12 @@
 
 */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
 #include <assert.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/bio.h>
 #include <openssl/evp.h>
@@ -228,7 +230,7 @@
 			{
 			i=ctx->buf_len-ctx->buf_off;
 			if (i > outl) i=outl;
-			memcpy(out,&(ctx->buf[ctx->buf_off]),i);
+			op_memcpy(out,&(ctx->buf[ctx->buf_off]),i);
 			ret+=i;
 			out+=i;
 			outl-=i;
@@ -243,7 +245,7 @@
 				if(ctx->buf_len_save- ctx->buf_off_save > 0)
 					{
 					ctx->buf_len= ctx->buf_len_save- ctx->buf_off_save;
-					memmove(ctx->buf, &(ctx->buf[ctx->buf_off_save]),
+					op_memmove(ctx->buf, &(ctx->buf[ctx->buf_off_save]),
 							ctx->buf_len);
 					}
 				else
@@ -325,7 +327,7 @@
 		n= (inl+ ctx->buf_len > OK_BLOCK_SIZE+ OK_BLOCK_BLOCK) ? 
 			(int)(OK_BLOCK_SIZE+OK_BLOCK_BLOCK-ctx->buf_len) : inl;
 
-		memcpy((unsigned char *)(&(ctx->buf[ctx->buf_len])),(unsigned char *)in,n);
+		op_memcpy((unsigned char *)(&(ctx->buf[ctx->buf_len])),(unsigned char *)in,n);
 		ctx->buf_len+= n;
 		inl-=n;
 		in+=n;
@@ -470,11 +472,11 @@
 	 * particularly now EVP_MD_CTX has been restructured.
 	 */
 	RAND_pseudo_bytes(md->md_data, md->digest->md_size);
-	memcpy(&(ctx->buf[ctx->buf_len]), md->md_data, md->digest->md_size);
+	op_memcpy(&(ctx->buf[ctx->buf_len]), md->md_data, md->digest->md_size);
 	longswap(&(ctx->buf[ctx->buf_len]), md->digest->md_size);
 	ctx->buf_len+= md->digest->md_size;
 
-	EVP_DigestUpdate(md, WELLKNOWN, strlen(WELLKNOWN));
+	EVP_DigestUpdate(md, WELLKNOWN, op_strlen(WELLKNOWN));
 	EVP_DigestFinal_ex(md, &(ctx->buf[ctx->buf_len]), NULL);
 	ctx->buf_len+= md->digest->md_size;
 	ctx->blockout= 1;
@@ -494,20 +496,20 @@
 	if((int)(ctx->buf_len-ctx->buf_off) < 2*md->digest->md_size) return;
 
 	EVP_DigestInit_ex(md, md->digest, NULL);
-	memcpy(md->md_data, &(ctx->buf[ctx->buf_off]), md->digest->md_size);
+	op_memcpy(md->md_data, &(ctx->buf[ctx->buf_off]), md->digest->md_size);
 	longswap(md->md_data, md->digest->md_size);
 	ctx->buf_off+= md->digest->md_size;
 
-	EVP_DigestUpdate(md, WELLKNOWN, strlen(WELLKNOWN));
+	EVP_DigestUpdate(md, WELLKNOWN, op_strlen(WELLKNOWN));
 	EVP_DigestFinal_ex(md, tmp, NULL);
-	ret= memcmp(&(ctx->buf[ctx->buf_off]), tmp, md->digest->md_size) == 0;
+	ret= op_memcmp(&(ctx->buf[ctx->buf_off]), tmp, md->digest->md_size) == 0;
 	ctx->buf_off+= md->digest->md_size;
 	if(ret == 1)
 		{
 		ctx->sigio= 0;
 		if(ctx->buf_len != ctx->buf_off)
 			{
-			memmove(ctx->buf, &(ctx->buf[ctx->buf_off]), ctx->buf_len- ctx->buf_off);
+			op_memmove(ctx->buf, &(ctx->buf[ctx->buf_off]), ctx->buf_len- ctx->buf_off);
 			}
 		ctx->buf_len-= ctx->buf_off;
 		ctx->buf_off= 0;
@@ -558,7 +560,7 @@
  
 	EVP_DigestUpdate(md, (unsigned char*) &(ctx->buf[OK_BLOCK_BLOCK]), tl);
 	EVP_DigestFinal_ex(md, tmp, NULL);
-	if(memcmp(&(ctx->buf[tl+ OK_BLOCK_BLOCK]), tmp, md->digest->md_size) == 0)
+	if(op_memcmp(&(ctx->buf[tl+ OK_BLOCK_BLOCK]), tmp, md->digest->md_size) == 0)
 		{
 		/* there might be parts from next block lurking around ! */
 		ctx->buf_off_save= tl+ OK_BLOCK_BLOCK+ md->digest->md_size;
diff -Naur openssl-1.0.0q.orig/crypto/evp/c_all.c openssl-1.0.0q/crypto/evp/c_all.c
--- openssl-1.0.0q.orig/crypto/evp/c_all.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/c_all.c	2017-04-25 16:23:40.334322655 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #ifndef OPENSSL_NO_ENGINE
diff -Naur openssl-1.0.0q.orig/crypto/evp/c_allc.c openssl-1.0.0q/crypto/evp/c_allc.c
--- openssl-1.0.0q.orig/crypto/evp/c_allc.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/c_allc.c	2017-04-25 16:23:40.335321665 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/pkcs12.h>
 #include <openssl/objects.h>
@@ -66,6 +68,8 @@
 	{
 
 #ifndef OPENSSL_NO_DES
+
+#ifndef OPERA_SMALL_VERSION
 	EVP_add_cipher(EVP_des_cfb());
 	EVP_add_cipher(EVP_des_cfb1());
 	EVP_add_cipher(EVP_des_cfb8());
@@ -86,18 +90,25 @@
 	EVP_add_cipher_alias(SN_des_cbc,"DES");
 	EVP_add_cipher_alias(SN_des_cbc,"des");
 	EVP_add_cipher(EVP_des_ede_cbc());
+#endif /* !OPERA_SMALL_VERSION */
+
 	EVP_add_cipher(EVP_des_ede3_cbc());
 	EVP_add_cipher_alias(SN_des_ede3_cbc,"DES3");
 	EVP_add_cipher_alias(SN_des_ede3_cbc,"des3");
 
+#ifndef OPERA_SMALL_VERSION
 	EVP_add_cipher(EVP_des_ecb());
 	EVP_add_cipher(EVP_des_ede());
 	EVP_add_cipher(EVP_des_ede3());
+#endif /* !OPERA_SMALL_VERSION */
+
 #endif
 
 #ifndef OPENSSL_NO_RC4
 	EVP_add_cipher(EVP_rc4());
+#ifndef OPERA_SMALL_VERSION
 	EVP_add_cipher(EVP_rc4_40());
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #ifndef OPENSSL_NO_IDEA
@@ -119,14 +130,24 @@
 #endif
 
 #ifndef OPENSSL_NO_RC2
+#ifdef RC2_CBC_ONLY
+	EVP_add_cipher(EVP_rc2_cbc());
+	EVP_add_cipher_alias(SN_rc2_cbc,"RC2");
+	EVP_add_cipher_alias(SN_rc2_cbc,"rc2");
+#else
+#ifndef OPERA_SMALL_VERSION
 	EVP_add_cipher(EVP_rc2_ecb());
 	EVP_add_cipher(EVP_rc2_cfb());
 	EVP_add_cipher(EVP_rc2_ofb());
+#endif /* !OPERA_SMALL_VERSION */
 	EVP_add_cipher(EVP_rc2_cbc());
 	EVP_add_cipher(EVP_rc2_40_cbc());
+#ifndef OPERA_SMALL_VERSION
 	EVP_add_cipher(EVP_rc2_64_cbc());
+#endif /* !OPERA_SMALL_VERSION */
 	EVP_add_cipher_alias(SN_rc2_cbc,"RC2");
 	EVP_add_cipher_alias(SN_rc2_cbc,"rc2");
+#endif // RC2_CBC_ONLY
 #endif
 
 #ifndef OPENSSL_NO_BF
@@ -160,6 +181,14 @@
 #endif
 
 #ifndef OPENSSL_NO_AES
+#ifdef OPERA_SMALL_VERSION
+	EVP_add_cipher(EVP_aes_128_cbc());
+	EVP_add_cipher_alias(SN_aes_128_cbc,"AES128");
+	EVP_add_cipher_alias(SN_aes_128_cbc,"aes128");
+	EVP_add_cipher(EVP_aes_256_cbc());
+	EVP_add_cipher_alias(SN_aes_256_cbc,"AES256");
+	EVP_add_cipher_alias(SN_aes_256_cbc,"aes256");
+#else
 	EVP_add_cipher(EVP_aes_128_ecb());
 	EVP_add_cipher(EVP_aes_128_cbc());
 	EVP_add_cipher(EVP_aes_128_cfb());
@@ -193,6 +222,7 @@
 #endif
 	EVP_add_cipher_alias(SN_aes_256_cbc,"AES256");
 	EVP_add_cipher_alias(SN_aes_256_cbc,"aes256");
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #ifndef OPENSSL_NO_CAMELLIA
diff -Naur openssl-1.0.0q.orig/crypto/evp/c_alld.c openssl-1.0.0q/crypto/evp/c_alld.c
--- openssl-1.0.0q.orig/crypto/evp/c_alld.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/c_alld.c	2017-04-25 16:23:40.335321665 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/pkcs12.h>
 #include <openssl/objects.h>
@@ -67,11 +69,19 @@
 #ifndef OPENSSL_NO_MD4
 	EVP_add_digest(EVP_md4());
 #endif
+#if !defined LIBOPEAY_DISABLE_MD5_PARTIAL
+	if(!g_turn_off_md5)
+	{
 #ifndef OPENSSL_NO_MD5
 	EVP_add_digest(EVP_md5());
 	EVP_add_digest_alias(SN_md5,"ssl2-md5");
 	EVP_add_digest_alias(SN_md5,"ssl3-md5");
 #endif
+	}
+#endif /* LIBOPEAY_DISABLE_MD5_PARTIAL */
+#if !defined OPENSSL_NO_SHA && !defined LIBOPEAY_DISABLE_SHA1_PARTIAL
+	if(!g_turn_off_sha1)
+	{
 #if !defined(OPENSSL_NO_SHA) && !defined(OPENSSL_NO_SHA0)
 	EVP_add_digest(EVP_sha());
 #ifndef OPENSSL_NO_DSA
@@ -92,6 +102,8 @@
 	EVP_add_digest(EVP_ecdsa());
 #endif
 #endif
+	}
+#endif
 #if !defined(OPENSSL_NO_MDC2) && !defined(OPENSSL_NO_DES)
 	EVP_add_digest(EVP_mdc2());
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/digest.c openssl-1.0.0q/crypto/evp/digest.c
--- openssl-1.0.0q.orig/crypto/evp/digest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/digest.c	2017-04-25 16:23:40.336321792 +0200
@@ -109,8 +109,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #ifndef OPENSSL_NO_ENGINE
@@ -119,12 +122,15 @@
 
 void EVP_MD_CTX_init(EVP_MD_CTX *ctx)
 	{
-	memset(ctx,'\0',sizeof *ctx);
+	op_memset(ctx,'\0',sizeof *ctx);
 	}
 
 EVP_MD_CTX *EVP_MD_CTX_create(void)
 	{
-	EVP_MD_CTX *ctx=OPENSSL_malloc(sizeof *ctx);
+	EVP_MD_CTX *ctx=(EVP_MD_CTX *)OPENSSL_malloc(sizeof *ctx);
+
+	if (!ctx)
+		return NULL;
 
 	if (ctx)
 		EVP_MD_CTX_init(ctx);
@@ -164,9 +170,11 @@
 				return 0;
 				}
 			}
+#ifndef OPERA_SMALL_VERSION
 		else
 			/* Ask if an ENGINE is reserved for this job */
 			impl = ENGINE_get_digest_engine(type->type);
+#endif
 		if(impl)
 			{
 			/* There's an ENGINE for this job ... (apparently) */
@@ -225,11 +233,18 @@
 		}
 	if (ctx->flags & EVP_MD_CTX_FLAG_NO_INIT)
 		return 1;
+
+	if (!ctx->md_data)		// can happen because of OOM earlier
+		return 0;
+
 	return ctx->digest->init(ctx);
 	}
 
 int EVP_DigestUpdate(EVP_MD_CTX *ctx, const void *data, size_t count)
 	{
+	if (!ctx->md_data)		// can happen because of OOM earlier
+		return 0;
+
 	return ctx->update(ctx,data,count);
 	}
 
@@ -248,6 +263,9 @@
 	int ret;
 
 	OPENSSL_assert(ctx->digest->md_size <= EVP_MAX_MD_SIZE);
+	if (!ctx->md_data)		// can happen because of OOM earlier
+		return 0;
+
 	ret=ctx->digest->final(ctx,md);
 	if (size != NULL)
 		*size=ctx->digest->md_size;
@@ -256,7 +274,7 @@
 		ctx->digest->cleanup(ctx);
 		EVP_MD_CTX_set_flags(ctx,EVP_MD_CTX_FLAG_CLEANED);
 		}
-	memset(ctx->md_data,0,ctx->digest->ctx_size);
+	op_memset(ctx->md_data,0,ctx->digest->ctx_size);
 	return ret;
 	}
 
@@ -285,12 +303,12 @@
 
 	if (out->digest == in->digest)
 		{
-		tmp_buf = out->md_data;
+		tmp_buf = (unsigned char *) out->md_data;
 	    	EVP_MD_CTX_set_flags(out,EVP_MD_CTX_FLAG_REUSE);
 		}
 	else tmp_buf = NULL;
 	EVP_MD_CTX_cleanup(out);
-	memcpy(out,in,sizeof *out);
+	op_memcpy(out,in,sizeof *out);
 
 	if (in->md_data && out->digest->ctx_size)
 		{
@@ -305,7 +323,7 @@
 				return 0;
 				}
 			}
-		memcpy(out->md_data,in->md_data,out->digest->ctx_size);
+		op_memcpy(out->md_data,in->md_data,out->digest->ctx_size);
 		}
 
 	out->update = in->update;
@@ -374,7 +392,7 @@
 		 * functional reference we held for this reason. */
 		ENGINE_finish(ctx->engine);
 #endif
-	memset(ctx,'\0',sizeof *ctx);
+	op_memset(ctx,'\0',sizeof *ctx);
 
 	return 1;
 	}
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_aes.c openssl-1.0.0q/crypto/evp/e_aes.c
--- openssl-1.0.0q.orig/crypto/evp/e_aes.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_aes.c	2017-04-25 16:23:40.337321919 +0200
@@ -52,10 +52,13 @@
 #ifndef OPENSSL_NO_AES
 #include <openssl/evp.h>
 #include <openssl/err.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
 #include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/aes.h>
 #include "evp_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int aes_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 					const unsigned char *iv, int enc);
@@ -73,12 +76,16 @@
 		       EVP_CIPHER_set_asn1_iv,
 		       EVP_CIPHER_get_asn1_iv,
 		       NULL)
+
+#if !defined _SSL_USE_OPENSSL_ || defined OPENSSL_USE_CFB_CIPHERS
 IMPLEMENT_BLOCK_CIPHER(aes_192, ks, AES, EVP_AES_KEY,
 		       NID_aes_192, 16, 24, 16, 128,
 		       0, aes_init_key, NULL, 
 		       EVP_CIPHER_set_asn1_iv,
 		       EVP_CIPHER_get_asn1_iv,
 		       NULL)
+#endif
+
 IMPLEMENT_BLOCK_CIPHER(aes_256, ks, AES, EVP_AES_KEY,
 		       NID_aes_256, 16, 32, 16, 128,
 		       0, aes_init_key, NULL, 
@@ -86,6 +93,7 @@
 		       EVP_CIPHER_get_asn1_iv,
 		       NULL)
 
+#if (!defined _SSL_USE_OPENSSL_ && !defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined OPENSSL_USE_CFB_CIPHERS
 #define IMPLEMENT_AES_CFBR(ksize,cbits)	IMPLEMENT_CFBR(aes,AES,EVP_AES_KEY,ks,ksize,cbits,16)
 
 IMPLEMENT_AES_CFBR(128,1)
@@ -95,6 +103,7 @@
 IMPLEMENT_AES_CFBR(128,8)
 IMPLEMENT_AES_CFBR(192,8)
 IMPLEMENT_AES_CFBR(256,8)
+#endif
 
 static int aes_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 		   const unsigned char *iv, int enc)
@@ -104,9 +113,9 @@
 	if ((ctx->cipher->flags & EVP_CIPH_MODE) == EVP_CIPH_CFB_MODE
 	    || (ctx->cipher->flags & EVP_CIPH_MODE) == EVP_CIPH_OFB_MODE
 	    || enc) 
-		ret=AES_set_encrypt_key(key, ctx->key_len * 8, ctx->cipher_data);
+		ret=AES_set_encrypt_key(key, ctx->key_len * 8, (AES_KEY *) ctx->cipher_data);
 	else
-		ret=AES_set_decrypt_key(key, ctx->key_len * 8, ctx->cipher_data);
+		ret=AES_set_decrypt_key(key, ctx->key_len * 8, (AES_KEY *) ctx->cipher_data);
 
 	if(ret < 0)
 		{
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_bf.c openssl-1.0.0q/crypto/evp/e_bf.c
--- openssl-1.0.0q.orig/crypto/evp/e_bf.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_bf.c	2017-04-25 16:23:40.338322046 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #ifndef OPENSSL_NO_BF
 #include <openssl/evp.h>
 #include "evp_locl.h"
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_cast.c openssl-1.0.0q/crypto/evp/e_cast.c
--- openssl-1.0.0q.orig/crypto/evp/e_cast.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_cast.c	2017-04-25 16:23:40.339322453 +0200
@@ -56,10 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
-#include <stdio.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_CAST
+
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include "evp_locl.h"
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_des.c openssl-1.0.0q/crypto/evp/e_des.c
--- openssl-1.0.0q.orig/crypto/evp/e_des.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_des.c	2017-04-25 16:23:40.340322021 +0200
@@ -56,9 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #ifndef OPENSSL_NO_DES
+#ifndef NO_SINGLE_DES
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include "evp_locl.h"
@@ -71,6 +74,7 @@
 
 /* Because of various casts and different names can't use IMPLEMENT_BLOCK_CIPHER */
 
+#ifndef OPERA_SMALL_VERSION
 static int des_ecb_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			  const unsigned char *in, size_t inl)
 {
@@ -78,7 +82,9 @@
 		DES_ecb_encrypt((DES_cblock *)(in + i), (DES_cblock *)(out + i), ctx->cipher_data, ctx->encrypt);
 	return 1;
 }
+#endif
 
+#ifndef DES_PART_ONLY
 static int des_ofb_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			  const unsigned char *in, size_t inl)
 {
@@ -95,37 +101,39 @@
 				(DES_cblock *)ctx->iv, &ctx->num);
 	return 1;
 }
+#endif
 
 static int des_cbc_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			  const unsigned char *in, size_t inl)
 {
 	while(inl>=EVP_MAXCHUNK)
 		{
-		DES_ncbc_encrypt(in, out, (long)EVP_MAXCHUNK, ctx->cipher_data,
+		DES_ncbc_encrypt(in, out, (long)EVP_MAXCHUNK, (DES_key_schedule *)ctx->cipher_data,
 				(DES_cblock *)ctx->iv, ctx->encrypt);
 		inl-=EVP_MAXCHUNK;
 		in +=EVP_MAXCHUNK;
 		out+=EVP_MAXCHUNK;
 		}
 	if (inl)
-		DES_ncbc_encrypt(in, out, (long)inl, ctx->cipher_data,
+		DES_ncbc_encrypt(in, out, (long)inl, (DES_key_schedule *)ctx->cipher_data,
 				(DES_cblock *)ctx->iv, ctx->encrypt);
 	return 1;
 }
 
+#if !defined _SSL_USE_OPENSSL_ || defined OPENSSL_USE_CFB_CIPHERS
 static int des_cfb64_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			    const unsigned char *in, size_t inl)
 {
 	while(inl>=EVP_MAXCHUNK)
 		{
-		DES_cfb64_encrypt(in,out, (long)EVP_MAXCHUNK, ctx->cipher_data,
+		DES_cfb64_encrypt(in,out, (long)EVP_MAXCHUNK, (DES_key_schedule *)ctx->cipher_data,
 				(DES_cblock *)ctx->iv, &ctx->num, ctx->encrypt);
 		inl-=EVP_MAXCHUNK;
 		in +=EVP_MAXCHUNK;
 		out+=EVP_MAXCHUNK;
 		}
 	if (inl)
-		DES_cfb64_encrypt(in, out, (long)inl, ctx->cipher_data,
+		DES_cfb64_encrypt(in, out, (long)inl, (DES_key_schedule *)ctx->cipher_data,
 			  (DES_cblock *)ctx->iv, &ctx->num, ctx->encrypt);
 	return 1;
 }
@@ -145,7 +153,7 @@
 	for(n=0 ; n < chunk*8; ++n)
 	    {
 	    c[0]=(in[n/8]&(1 << (7-n%8))) ? 0x80 : 0;
-	    DES_cfb_encrypt(c,d,1,1,ctx->cipher_data,(DES_cblock *)ctx->iv,
+	    DES_cfb_encrypt(c,d,1,1,(DES_key_schedule *)ctx->cipher_data,(DES_cblock *)ctx->iv,
 			ctx->encrypt);
 	    out[n/8]=(out[n/8]&~(0x80 >> (unsigned int)(n%8))) |
 		     ((d[0]&0x80) >> (unsigned int)(n%8));
@@ -171,10 +179,11 @@
 	out+=EVP_MAXCHUNK;
 	}
     if (inl)
-	DES_cfb_encrypt(in,out,8,(long)inl,ctx->cipher_data,
+	DES_cfb_encrypt(in,out,8,(long)inl,(DES_key_schedule *)ctx->cipher_data,
 			(DES_cblock *)ctx->iv,ctx->encrypt);
     return 1;
     }
+#endif
 
 BLOCK_CIPHER_defs(des, DES_key_schedule, NID_des, 8, 8, 8, 64,
 			EVP_CIPH_RAND_KEY, des_init_key, NULL,
@@ -182,6 +191,7 @@
 			EVP_CIPHER_get_asn1_iv,
 			des_ctrl)
 
+#if !defined _SSL_USE_OPENSSL_ || defined OPENSSL_USE_CFB_CIPHERS
 BLOCK_CIPHER_def_cfb(des,DES_key_schedule,NID_des,8,8,1,
 		     EVP_CIPH_RAND_KEY, des_init_key,NULL,
 		     EVP_CIPHER_set_asn1_iv,
@@ -191,6 +201,7 @@
 		     EVP_CIPH_RAND_KEY,des_init_key,NULL,
 		     EVP_CIPHER_set_asn1_iv,
 		     EVP_CIPHER_get_asn1_iv,des_ctrl)
+#endif
 
 static int des_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			const unsigned char *iv, int enc)
@@ -200,7 +211,7 @@
 	if(DES_set_key_checked(deskey,ctx->cipher_data) != 0)
 		return 0;
 #else
-	DES_set_key_unchecked(deskey,ctx->cipher_data);
+	DES_set_key_unchecked(deskey, (DES_key_schedule *) ctx->cipher_data);
 #endif
 	return 1;
 	}
@@ -211,7 +222,7 @@
 	switch(type)
 		{
 	case EVP_CTRL_RAND_KEY:
-		if (RAND_bytes(ptr, 8) <= 0)
+		if (RAND_bytes((unsigned char *) ptr, 8) <= 0)
 			return 0;
 		DES_set_odd_parity((DES_cblock *)ptr);
 		return 1;
@@ -222,3 +233,4 @@
 	}
 
 #endif
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_des3.c openssl-1.0.0q/crypto/evp/e_des3.c
--- openssl-1.0.0q.orig/crypto/evp/e_des3.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_des3.c	2017-04-25 16:23:40.341321869 +0200
@@ -56,22 +56,29 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #ifndef OPENSSL_NO_DES
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include "evp_locl.h"
 #include <openssl/des.h>
 #include <openssl/rand.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 static int des_ede_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			    const unsigned char *iv,int enc);
+#endif
 
 static int des_ede3_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			     const unsigned char *iv,int enc);
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 static int des3_ctrl(EVP_CIPHER_CTX *c, int type, int arg, void *ptr);
+#endif
 
 typedef struct
     {
@@ -84,6 +91,7 @@
 
 /* Because of various casts and different args can't use IMPLEMENT_BLOCK_CIPHER */
 
+#ifndef OPERA_SMALL_VERSION
 static int des_ede_ecb_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			      const unsigned char *in, size_t inl)
 {
@@ -95,7 +103,9 @@
 				 ctx->encrypt);
 	return 1;
 }
+#endif
 
+#ifndef DES_PART_ONLY
 static int des_ede_ofb_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			      const unsigned char *in, size_t inl)
 {
@@ -115,6 +125,7 @@
 
 	return 1;
 }
+#endif
 
 static int des_ede_cbc_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			      const unsigned char *in, size_t inl)
@@ -146,6 +157,8 @@
 	return 1;
 }
 
+#ifdef DES_PART_ONLY
+#if (!defined _SSL_USE_OPENSSL_ && !defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION )|| defined OPENSSL_USE_CFB_CIPHERS
 static int des_ede_cfb64_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 			      const unsigned char *in, size_t inl)
 {
@@ -204,12 +217,16 @@
 			(DES_cblock *)ctx->iv,ctx->encrypt);
     return 1;
     }
+#endif
+#endif
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 BLOCK_CIPHER_defs(des_ede, DES_EDE_KEY, NID_des_ede, 8, 16, 8, 64,
 			EVP_CIPH_RAND_KEY, des_ede_init_key, NULL, 
 			EVP_CIPHER_set_asn1_iv,
 			EVP_CIPHER_get_asn1_iv,
 			des3_ctrl)
+#endif
 
 #define des_ede3_cfb64_cipher des_ede_cfb64_cipher
 #define des_ede3_ofb_cipher des_ede_ofb_cipher
@@ -222,6 +239,7 @@
 			EVP_CIPHER_get_asn1_iv,
 			des3_ctrl)
 
+#if (!defined _SSL_USE_OPENSSL_ && !defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION ) || defined OPENSSL_USE_CFB_CIPHERS
 BLOCK_CIPHER_def_cfb(des_ede3,DES_EDE_KEY,NID_des_ede3,24,8,1,
 		     EVP_CIPH_RAND_KEY, des_ede3_init_key,NULL,
 		     EVP_CIPHER_set_asn1_iv,
@@ -233,7 +251,9 @@
 		     EVP_CIPHER_set_asn1_iv,
 		     EVP_CIPHER_get_asn1_iv,
 		     des3_ctrl)
+#endif
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 static int des_ede_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			    const unsigned char *iv, int enc)
 	{
@@ -246,10 +266,11 @@
 	DES_set_key_unchecked(&deskey[0],&data(ctx)->ks1);
 	DES_set_key_unchecked(&deskey[1],&data(ctx)->ks2);
 #endif
-	memcpy(&data(ctx)->ks3,&data(ctx)->ks1,
+	op_memcpy(&data(ctx)->ks3,&data(ctx)->ks1,
 	       sizeof(data(ctx)->ks1));
 	return 1;
 	}
+#endif
 
 static int des_ede3_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			     const unsigned char *iv, int enc)
@@ -279,15 +300,16 @@
 	return 1;
 	}
 
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 static int des3_ctrl(EVP_CIPHER_CTX *c, int type, int arg, void *ptr)
 	{
 
-	DES_cblock *deskey = ptr;
+	DES_cblock *deskey = (DES_cblock *) ptr;
 
 	switch(type)
 		{
 	case EVP_CTRL_RAND_KEY:
-		if (RAND_bytes(ptr, c->key_len) <= 0)
+		if (RAND_bytes((unsigned char *) ptr, c->key_len) <= 0)
 			return 0;
 		DES_set_odd_parity(deskey);
 		if (c->key_len >= 16)
@@ -300,7 +322,9 @@
 		return -1;
 		}
 	}
+#endif
 
+#ifndef DES_PART_ONLY
 const EVP_CIPHER *EVP_des_ede(void)
 {
 	return &des_ede_ecb;
@@ -311,3 +335,5 @@
 	return &des_ede3_ecb;
 }
 #endif
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_dsa.c openssl-1.0.0q/crypto/evp/e_dsa.c
--- openssl-1.0.0q.orig/crypto/evp/e_dsa.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_dsa.c	2017-04-25 16:23:40.342321437 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/objects.h>
